<HTML>

<HEAD>
<link rel="stylesheet" type="text/css"
href="halstyle.css">
</HEAD>

<BODY TEXT="#000000" LINK="#0000ff" VLINK="#551a8b" ALINK="#ff0000"">
<H1>Bergse Halreservation</H1> <BR>

<?php
//show_source("HalRes.php");
error_reporting(!E_NOTICE);

	/*****************************************************
	 *       Bookingsystem til Bergse Boldklub          *
	 *       Author: Anders Rasmussen 1011               *
	 * 	 Version: 4.1				     *
	 *       Med login og password		             *
	 *       					     *
	 *****************************************************/

	/* Funktionalitet: 4.1
	 - Man kan ikke reservere oven i hinanden.
	 - Admin kan slette reservationer - flyttet til ekstern adminside. 
	 - Automatisk ugeangivelse og oprykning af ude 2 til uge 1's plads. Blankt skema til U3
	 - Login og Password til alle brugere, ellers kan man kun se, hvad der er optaget
	 - Man reserverer/afmelder ved at klikke p den skemaplacering man nsker at reservere/afmelde.
	 - 
	 - Mulighed for selv at afmelde sin reservering.  
	 - Bug, der muliggrer at slette andres reservationer rettet. 
	 - Skemaets dimensioner er nu fastlste. 
         - Backup af gamle skemaer.
         - Ens egne reservationer str med fed. 
         - Det str angivet, hvem man er logget ind som (gst, hvis intet login).
         - Skemaerne udskrives nu via for-lkker. 
	 - Regler for max reservationer per dag indfrt(med forklarende tekst).
	 - Forklarende tekst generelt. 
	 - Rettet til de nye tider. 
	 - Automatisk angivelse af tider. 
	 - Skema Backup rettet s gamle skemaer (fra 1 r tilbage) overskrives helt af de nye. 
          Kommende funktioner:	
	  
          -Forhinder retning af data fra tidligere ugedag (rette onsdag om fredagen)
	*/	             


	//Definerer Skema-Databasen
$dbdef=
array (
	array("person","C",50),
	array("ledig","N",2,0)
      );

$Aflysninger=array ( array("dag1","C",20), array("dag2","C",20),array("dag3","C",20) );


	//Dynamiske variable
$brugerfil="x_brugere8.dbf";
$aflfil="aflysning.dbf";


	//Diverse variable initialiceres
$Person=$_GET["person"];
$Login=$_GET["login"];
$Pass=$_GET["pass"];
$TimeID=$_GET["timeid"];
$Ledigt="Ledig";
$thisDay=Date("l");
$UserValid=0;
$MoreThanTwo=FALSE;
$Week=Date("W");


/******************************************************************
*                   Validerer brugeren                            *
*******************************************************************/
function UserValid($UserValid,$Login,$Pass)
{
    $brugere= dbase_open("x_brugere8.dbf",2);
    $BrugerDbSize=dbase_numrecords($brugere);
    
    
    $i=1;
      do
        {
        $Bruger = dbase_get_record($brugere,$i);
        $Pers=trim($Bruger[0]);
        $Pas=trim($Bruger[1]);
        if(($Login==$Pers)&&($Pass==$Pas))
		{
		$UserValid=1;
		}
	$i++;
	}
      while($UserValid!=1 && $i<$BrugerDbSize+1);
    
    if($UserValid)
	{
	print("Du er logget ind som $Login");
	}
	
    else	
	{print("Du er logget ind som gst");}

    dbase_close($brugere);
    return($UserValid);
}

/*
- Opretter et tomt skema, hvis der ikke er et skema i forvejen -   */
if(!file_exists("skema.dbf"))
	{
	if(!dbase_create("skema.dbf",$dbdef))
		{
		echo "error";
		}
	$skema = dbase_open("skema.dbf",2);
	for($skemapladser=0;$skemapladser<38;$skemapladser++)
		{
			$Haltid=array($Ledigt,1);
			dbase_add_record($skema,$Haltid);
		}
	$Week=array ("Dato",(Date("W")));
	$Haltid=array("X",0);
	dbase_replace_record($skema,$Week,37);
	dbase_replace_record($skema,$Haltid,1);
//	dbase_replace_record($skema,$Haltid,2);
	dbase_replace_record($skema,$Haltid,4);
	dbase_replace_record($skema,$Haltid,16);
	dbase_replace_record($skema,$Haltid,17);
	dbase_replace_record($skema,$Haltid,19);
	dbase_close($skema);
	}


/********************** Opretter Aflysnings-skemaet, hvis det ikke eksisterer ****************************/
if(!file_exists("aflysninger.dbf"))
	{
	if(!dbase_create("aflysninger.dbf",$Aflysninger))
		{
		echo "error";
		}
	$aflysning=dbase_open("aflysninger.dbf",2);	
	
	$IkkeAflyst=array("","","");
	for($uge=1;$uge<53;$uge++)
		{
			dbase_add_record($aflysning,$IkkeAflyst);	
		}
	}
dbase_close($aflysning);





/****************************************************************************** 
*- Funktion til at flytte reservationerne fra nederste skema op i det verste *
*  nr ugerne skifter. Det gamle skema lgges i en ny fil, til arkivering.    *
*******************************************************************************/

function SkemaRotation()
{
	
	$skema = dbase_open("skema.dbf",2);
	$Datoen=dbase_get_record($skema,37);	


	if( $Datoen[1]!=(Date("W"))  )
	{
        $GSkemafil="skema$Datoen[1].dbf";
				$gammeltskema = fopen("$GSkemafil","a+");
        $skemafil=fopen("skema.dbf","r");
				
				copy('skema.dbf',$GSkemafil);
	

		for($i=1;$i<16;$i++)
		{
			$TempArray=dbase_get_record($skema,($i+15));
			$Haltid=array("Ledig",1);
			dbase_replace_record($skema,$Haltid,($i+15));
			$InputArray= array($TempArray[0],$TempArray[1]);
			dbase_replace_record($skema,$InputArray,$i);

		}
		
		
	}
	$Week=array ("Dato",(Date("W")));
	dbase_replace_record($skema,$Week,37);
	dbase_close($skema);
}




/*************************************************************
*  Funktion, der forhindrer at en bruger kan booke mere end  *
*  2 timer p n dag.                                        *
**************************************************************/
function NoMoreThanTwo($TimeID,$Login,$Number)
{
	$NumRes=0;
	$NoMoreThanTwo=TRUE;
	$skema = dbase_open("skema.dbf",2);
	
	if( ($TimeID-16) < 0 )
		{
		$startval=1;
		$endval=16;
		}
	else
		{
		$startval=16;
		$endval=31;
		}
	
	

	for($i=$startval;$i<$endval;$i++)
		{
		$Halreservation = dbase_get_record($skema,$i);
		$Reservation=trim("$Halreservation[0]");

		if( ($TimeID%3==$i%3) && ("$Login"=="$Reservation") )
			{
			$NumRes++;
			}
		
		}

	if( $NumRes>($Number-1) and $Login!="Aflyser" )
		{
		$NoMoreThanTwo=FALSE;
		}
		
	dbase_close($skema);
	return($NoMoreThanTwo);
}



	/******************- Funktion til automatisk datoangivelse p dagene -**************/
function SetDates($TimeID,$Week)
{

	$weeks=$Week-2;
	if( ($TimeID%3) == 1 )   {$Reftime="Jan 7 2008";}  //Mandag
	elseif( ($TimeID%3) == 2 )   {$Reftime="Jan 12 2008";}  //Lrdag
	else 			  {$Reftime="Jan 13 2008";} //Sndag


	$StartStamp=strtotime("$Reftime +$weeks week");

	
print(" d. ");	
print(Date("j",$StartStamp));
print("/");
print(Date("n",$StartStamp));

}



/******************- ndrer "Ledig" til personens navn. Kan ogs slette reservationer - ******/

function AddReservation($Person, $TimeID,$UserValid,$Login,&$MoreThanTwo) 
{
	if(($UserValid==1)&&((GetReservation($TimeID)=="$Login") || (GetReservation($TimeID)=="Ledig")))
	{
	$skema = dbase_open("skema.dbf",2);
	
	if($Person==3141)//kode for SLET REGISTRERING
		{$Haltid=array("Ledig",1);}
	
	elseif(NoMoreThanTwo($TimeID,$Login,2))
		{$Haltid=array($Person,0);}
	
	else
		{
		$MoreThanTwo=TRUE;
		}
	

	dbase_replace_record($skema,$Haltid,$TimeID);
	dbase_close($skema);
	}
}



/*********- Metode til indhentelse af navnet p den person, der har reserveret en given tid. -*/

function GetReservation($TimeID)
{ 						
	$skema = dbase_open("skema.dbf",2);
	$Halreservation = dbase_get_record($skema,$TimeID);
	dbase_close($skema);
	return(trim("$Halreservation[0]"));
}




/********- Metode til at bestemme om en given tid er ledig - ***************************/

function Ledig($TimeID)
{ 						
	$skema = dbase_open("skema.dbf",2);
	$Halreservation = dbase_get_record($skema,$TimeID);
	dbase_close($skema);
	return($Halreservation[1]);	
}


function CellContent($Login,$Pass,$UserValid,$CellNumber)
{
	$Week=Date("W");
		$aflysning=dbase_open("aflysninger.dbf",2);
		$AflArray1=dbase_get_record($aflysning,$Week);	
		$AflArray2=dbase_get_record($aflysning,($Week+1));
		$tmp1=(($CellNumber-1)%3);
		$Afl1=trim($AflArray1[$tmp1]);
		$Afl2=trim($AflArray2[$tmp1]);	
	
	
	
	
		if($CellNumber==1 || $CellNumber==2 || $CellNumber==4 ||  
     		 $CellNumber==16 || $CellNumber==17 || $CellNumber==19)  //7 og 22 er nu gyldige
     	{
     		print("X");
     	}	
    elseif($Afl1 != "" && $CellNumber<16)	
		{
			print("$Afl1");
		}
		
		elseif($Afl2[$tmp1] != "" && $CellNumber>15)
		{
			print("$Afl2");
		}
	
    elseif($UserValid==1)
     {
        
     	 	
     	if((GetReservation($CellNumber))=="Ledig")
      {
      	$Link=("<a href=HalRes2.php?timeid=$CellNumber&pass=$Pass&login=$Login&person=$Login>Reservr</a>");
        print($Link);
      }
      
      else
      {
       	if(GetReservation($CellNumber)==$Login)
				{
					$DeleteLink=("<a href=HalRes2.php?timeid=$CellNumber&pass=$Pass&login=$Login&person=3141>Afmeld</a>");
					print("<b> $Login   $DeleteLink </b>");
				}
        
        //elseif(GetReservation($CellNumber)=="X")
       	//{
       		
       	//}
       	elseif(GetReservation($CellNumber)=="Aflyser")	{print("AFLYST");}
        else {print(GetReservation($CellNumber));}		//print("Optaget");}    //Nu kan alle se hinandens reservationer
                           
      }
    }


    else
        {
        if((GetReservation($CellNumber))=="Ledig")      {print("Ledig");}
            
        else{print("Optaget");}
        }
}



/**************************************************************************
*	Funktion til udskrivelse af forklarende tekst			  *
***************************************************************************/
function PrintText()
{
	$text = fopen("halregler.txt","r");
	$textlines = fgets($text,10000); 
	print('<TABLE width="60%"><TR VALIGN="TOP"><TD>');
	print("$textlines");
	print('</TD> </TR> </TABLE>');
}



/********************************************************************************************** 
*	- Hvis pladsen er ledig og personen har angivet et navn kaldes "AddReservation" -     *
*       - Er navnet "Aflyser" slettes reservationen af samme metode -                         *
***********************************************************************************************/

$UserValid=UserValid($UserValid,$Login,$Pass);



if($Person!="")
	{
	AddReservation($Person,$TimeID,$UserValid,$Login,&$MoreThanTwo);
        //print("Reservation gennemfrt!");
	}

SkemaRotation(); //Roterer skemaet, hvis ndvendigt. 

/*****************************************************************************************/




/*****************************************************************************************
 *                  Nedenstende udskriver de to skemaer                                 *
 *****************************************************************************************/

    //Kolonne bredder
$cWidth="20%";  //Bredde p reservationsfelter
$cWidth2="12%"; // Bredde p tidsfelter

$Tider = array(    "17-18","18-19","19-20", 
                    "20-21","21-22"
	      );
?>

<TABLE BORDER="1" WIDTH= "60%">
<TR VALIGN="TOP"><TD width=<?php echo $cWidth2;?>>Uge <?php print(Date("W"));?></TD>
<TD width=<?php echo ' '.$cWidth.' ;>Mandag ';SetDates(1,$Week);?></TD>
<TD width=<?php echo ' '.$cWidth.' ;>Lrdag ';SetDates(2,$Week);print'<BR>';?></TD>
<TD width=<?php echo ' '.$cWidth.' ;>S&oslash;ndag ';SetDates(0,$Week);?></TD> </TR>

<?php

    //Udskriver skema 1
for($i=0;$i<5;$i++)
    {
    print('<TR VALIGN="TOP"><TD width=');echo "$cWidth2 >"; echo $Tider[$i];print('</TD>');
    
    for($u=1;$u<4;$u++)
        {	
        print('<TD width=');echo "$cWidth >";CellContent($Login,$Pass,$UserValid,($u+3*$i));print('</TD>'); 
        }
    print('</TR>');
    }
print('</TABLE>');    

?>
<BR WP="BR1"><BR WP="BR2">
  
  
<TABLE BORDER="1" WIDTH= "60%">
<TR VALIGN="TOP"><TD width=<?php echo $cWidth2;?>>Uge <?php print(Date("W")+1);?></TD>
<TD width=<?php echo ' '.$cWidth.' ;>Mandag ';SetDates(1,$Week+1);?></TD>
<TD width=<?php echo ' '.$cWidth.' ;>Lrdag ';SetDates(2,$Week+1);print'<BR>';?></TD>
<TD width=<?php echo ' '.$cWidth.' ;>Sndag ';SetDates(0,$Week+1);?></TD> </TR>

<?php

//Udskriver skema2
for($i=0;$i<5;$i++)
    {
    print('<TR VALIGN="TOP"><TD width=');echo "$cWidth2 >"; echo $Tider[$i];print('</TD>');
    
    for($u=1;$u<4;$u++)
        {
        print('<TD width=');echo "$cWidth >";CellContent($Login,$Pass,$UserValid,($u+3*$i+15));print('</TD>'); 
        }
    print('</TR>');
    }
print('</TABLE>');   


if($MoreThanTwo)
	{
	print('<BR>');
	print("<H2> Du kan ikke reservere mere end to timer p n dag.  </H2>");
	}

print('<BR><BR>');
PrintText();
?>
<BR WP="BR1"><BR WP="BR2">


</BODY>
</HTML>
